/*
 * The codepage KOI8-R definitions
 *
 * Copyright (C) 2008-2019, Joachim Metz <joachim.metz@gmail.com>
 *
 * Refer to AUTHORS for acknowledgements.
 *
 * This software is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined( _UNA_TEST_CODEPAGE_KOI8_R_H )
#define _UNA_TEST_CODEPAGE_KOI8_R_H

#include <common.h>
#include <types.h>

#include "una_test_types.h"

#if defined( __cplusplus )
extern "C" {
#endif

una_test_byte_stream_to_unicode_t una_test_codepage_koi8_r_byte_stream_to_unicode[ 256 ] = {
	{ { 0x00 }, 1, 0x0000, 0 },
	{ { 0x01 }, 1, 0x0001, 0 },
	{ { 0x02 }, 1, 0x0002, 0 },
	{ { 0x03 }, 1, 0x0003, 0 },
	{ { 0x04 }, 1, 0x0004, 0 },
	{ { 0x05 }, 1, 0x0005, 0 },
	{ { 0x06 }, 1, 0x0006, 0 },
	{ { 0x07 }, 1, 0x0007, 0 },
	{ { 0x08 }, 1, 0x0008, 0 },
	{ { 0x09 }, 1, 0x0009, 0 },
	{ { 0x0a }, 1, 0x000a, 0 },
	{ { 0x0b }, 1, 0x000b, 0 },
	{ { 0x0c }, 1, 0x000c, 0 },
	{ { 0x0d }, 1, 0x000d, 0 },
	{ { 0x0e }, 1, 0x000e, 0 },
	{ { 0x0f }, 1, 0x000f, 0 },
	{ { 0x10 }, 1, 0x0010, 0 },
	{ { 0x11 }, 1, 0x0011, 0 },
	{ { 0x12 }, 1, 0x0012, 0 },
	{ { 0x13 }, 1, 0x0013, 0 },
	{ { 0x14 }, 1, 0x0014, 0 },
	{ { 0x15 }, 1, 0x0015, 0 },
	{ { 0x16 }, 1, 0x0016, 0 },
	{ { 0x17 }, 1, 0x0017, 0 },
	{ { 0x18 }, 1, 0x0018, 0 },
	{ { 0x19 }, 1, 0x0019, 0 },
	{ { 0x1a }, 1, 0x001a, 0 },
	{ { 0x1b }, 1, 0x001b, 0 },
	{ { 0x1c }, 1, 0x001c, 0 },
	{ { 0x1d }, 1, 0x001d, 0 },
	{ { 0x1e }, 1, 0x001e, 0 },
	{ { 0x1f }, 1, 0x001f, 0 },
	{ { 0x20 }, 1, 0x0020, 0 },
	{ { 0x21 }, 1, 0x0021, 0 },
	{ { 0x22 }, 1, 0x0022, 0 },
	{ { 0x23 }, 1, 0x0023, 0 },
	{ { 0x24 }, 1, 0x0024, 0 },
	{ { 0x25 }, 1, 0x0025, 0 },
	{ { 0x26 }, 1, 0x0026, 0 },
	{ { 0x27 }, 1, 0x0027, 0 },
	{ { 0x28 }, 1, 0x0028, 0 },
	{ { 0x29 }, 1, 0x0029, 0 },
	{ { 0x2a }, 1, 0x002a, 0 },
	{ { 0x2b }, 1, 0x002b, 0 },
	{ { 0x2c }, 1, 0x002c, 0 },
	{ { 0x2d }, 1, 0x002d, 0 },
	{ { 0x2e }, 1, 0x002e, 0 },
	{ { 0x2f }, 1, 0x002f, 0 },
	{ { 0x30 }, 1, 0x0030, 0 },
	{ { 0x31 }, 1, 0x0031, 0 },
	{ { 0x32 }, 1, 0x0032, 0 },
	{ { 0x33 }, 1, 0x0033, 0 },
	{ { 0x34 }, 1, 0x0034, 0 },
	{ { 0x35 }, 1, 0x0035, 0 },
	{ { 0x36 }, 1, 0x0036, 0 },
	{ { 0x37 }, 1, 0x0037, 0 },
	{ { 0x38 }, 1, 0x0038, 0 },
	{ { 0x39 }, 1, 0x0039, 0 },
	{ { 0x3a }, 1, 0x003a, 0 },
	{ { 0x3b }, 1, 0x003b, 0 },
	{ { 0x3c }, 1, 0x003c, 0 },
	{ { 0x3d }, 1, 0x003d, 0 },
	{ { 0x3e }, 1, 0x003e, 0 },
	{ { 0x3f }, 1, 0x003f, 0 },
	{ { 0x40 }, 1, 0x0040, 0 },
	{ { 0x41 }, 1, 0x0041, 0 },
	{ { 0x42 }, 1, 0x0042, 0 },
	{ { 0x43 }, 1, 0x0043, 0 },
	{ { 0x44 }, 1, 0x0044, 0 },
	{ { 0x45 }, 1, 0x0045, 0 },
	{ { 0x46 }, 1, 0x0046, 0 },
	{ { 0x47 }, 1, 0x0047, 0 },
	{ { 0x48 }, 1, 0x0048, 0 },
	{ { 0x49 }, 1, 0x0049, 0 },
	{ { 0x4a }, 1, 0x004a, 0 },
	{ { 0x4b }, 1, 0x004b, 0 },
	{ { 0x4c }, 1, 0x004c, 0 },
	{ { 0x4d }, 1, 0x004d, 0 },
	{ { 0x4e }, 1, 0x004e, 0 },
	{ { 0x4f }, 1, 0x004f, 0 },
	{ { 0x50 }, 1, 0x0050, 0 },
	{ { 0x51 }, 1, 0x0051, 0 },
	{ { 0x52 }, 1, 0x0052, 0 },
	{ { 0x53 }, 1, 0x0053, 0 },
	{ { 0x54 }, 1, 0x0054, 0 },
	{ { 0x55 }, 1, 0x0055, 0 },
	{ { 0x56 }, 1, 0x0056, 0 },
	{ { 0x57 }, 1, 0x0057, 0 },
	{ { 0x58 }, 1, 0x0058, 0 },
	{ { 0x59 }, 1, 0x0059, 0 },
	{ { 0x5a }, 1, 0x005a, 0 },
	{ { 0x5b }, 1, 0x005b, 0 },
	{ { 0x5c }, 1, 0x005c, 0 },
	{ { 0x5d }, 1, 0x005d, 0 },
	{ { 0x5e }, 1, 0x005e, 0 },
	{ { 0x5f }, 1, 0x005f, 0 },
	{ { 0x60 }, 1, 0x0060, 0 },
	{ { 0x61 }, 1, 0x0061, 0 },
	{ { 0x62 }, 1, 0x0062, 0 },
	{ { 0x63 }, 1, 0x0063, 0 },
	{ { 0x64 }, 1, 0x0064, 0 },
	{ { 0x65 }, 1, 0x0065, 0 },
	{ { 0x66 }, 1, 0x0066, 0 },
	{ { 0x67 }, 1, 0x0067, 0 },
	{ { 0x68 }, 1, 0x0068, 0 },
	{ { 0x69 }, 1, 0x0069, 0 },
	{ { 0x6a }, 1, 0x006a, 0 },
	{ { 0x6b }, 1, 0x006b, 0 },
	{ { 0x6c }, 1, 0x006c, 0 },
	{ { 0x6d }, 1, 0x006d, 0 },
	{ { 0x6e }, 1, 0x006e, 0 },
	{ { 0x6f }, 1, 0x006f, 0 },
	{ { 0x70 }, 1, 0x0070, 0 },
	{ { 0x71 }, 1, 0x0071, 0 },
	{ { 0x72 }, 1, 0x0072, 0 },
	{ { 0x73 }, 1, 0x0073, 0 },
	{ { 0x74 }, 1, 0x0074, 0 },
	{ { 0x75 }, 1, 0x0075, 0 },
	{ { 0x76 }, 1, 0x0076, 0 },
	{ { 0x77 }, 1, 0x0077, 0 },
	{ { 0x78 }, 1, 0x0078, 0 },
	{ { 0x79 }, 1, 0x0079, 0 },
	{ { 0x7a }, 1, 0x007a, 0 },
	{ { 0x7b }, 1, 0x007b, 0 },
	{ { 0x7c }, 1, 0x007c, 0 },
	{ { 0x7d }, 1, 0x007d, 0 },
	{ { 0x7e }, 1, 0x007e, 0 },
	{ { 0x7f }, 1, 0x007f, 0 },
	{ { 0x80 }, 1, 0x2500, 0 },
	{ { 0x81 }, 1, 0x2502, 0 },
	{ { 0x82 }, 1, 0x250c, 0 },
	{ { 0x83 }, 1, 0x2510, 0 },
	{ { 0x84 }, 1, 0x2514, 0 },
	{ { 0x85 }, 1, 0x2518, 0 },
	{ { 0x86 }, 1, 0x251c, 0 },
	{ { 0x87 }, 1, 0x2524, 0 },
	{ { 0x88 }, 1, 0x252c, 0 },
	{ { 0x89 }, 1, 0x2534, 0 },
	{ { 0x8a }, 1, 0x253c, 0 },
	{ { 0x8b }, 1, 0x2580, 0 },
	{ { 0x8c }, 1, 0x2584, 0 },
	{ { 0x8d }, 1, 0x2588, 0 },
	{ { 0x8e }, 1, 0x258c, 0 },
	{ { 0x8f }, 1, 0x2590, 0 },
	{ { 0x90 }, 1, 0x2591, 0 },
	{ { 0x91 }, 1, 0x2592, 0 },
	{ { 0x92 }, 1, 0x2593, 0 },
	{ { 0x93 }, 1, 0x2320, 0 },
	{ { 0x94 }, 1, 0x25a0, 0 },
	{ { 0x95 }, 1, 0x2219, 0 },
	{ { 0x96 }, 1, 0x221a, 0 },
	{ { 0x97 }, 1, 0x2248, 0 },
	{ { 0x98 }, 1, 0x2264, 0 },
	{ { 0x99 }, 1, 0x2265, 0 },
	{ { 0x9a }, 1, 0x00a0, 0 },
	{ { 0x9b }, 1, 0x2321, 0 },
	{ { 0x9c }, 1, 0x00b0, 0 },
	{ { 0x9d }, 1, 0x00b2, 0 },
	{ { 0x9e }, 1, 0x00b7, 0 },
	{ { 0x9f }, 1, 0x00f7, 0 },
	{ { 0xa0 }, 1, 0x2550, 0 },
	{ { 0xa1 }, 1, 0x2551, 0 },
	{ { 0xa2 }, 1, 0x2552, 0 },
	{ { 0xa3 }, 1, 0x0451, 0 },
	{ { 0xa4 }, 1, 0x2553, 0 },
	{ { 0xa5 }, 1, 0x2554, 0 },
	{ { 0xa6 }, 1, 0x2555, 0 },
	{ { 0xa7 }, 1, 0x2556, 0 },
	{ { 0xa8 }, 1, 0x2557, 0 },
	{ { 0xa9 }, 1, 0x2558, 0 },
	{ { 0xaa }, 1, 0x2559, 0 },
	{ { 0xab }, 1, 0x255a, 0 },
	{ { 0xac }, 1, 0x255b, 0 },
	{ { 0xad }, 1, 0x255c, 0 },
	{ { 0xae }, 1, 0x255d, 0 },
	{ { 0xaf }, 1, 0x255e, 0 },
	{ { 0xb0 }, 1, 0x255f, 0 },
	{ { 0xb1 }, 1, 0x2560, 0 },
	{ { 0xb2 }, 1, 0x2561, 0 },
	{ { 0xb3 }, 1, 0x0401, 0 },
	{ { 0xb4 }, 1, 0x2562, 0 },
	{ { 0xb5 }, 1, 0x2563, 0 },
	{ { 0xb6 }, 1, 0x2564, 0 },
	{ { 0xb7 }, 1, 0x2565, 0 },
	{ { 0xb8 }, 1, 0x2566, 0 },
	{ { 0xb9 }, 1, 0x2567, 0 },
	{ { 0xba }, 1, 0x2568, 0 },
	{ { 0xbb }, 1, 0x2569, 0 },
	{ { 0xbc }, 1, 0x256a, 0 },
	{ { 0xbd }, 1, 0x256b, 0 },
	{ { 0xbe }, 1, 0x256c, 0 },
	{ { 0xbf }, 1, 0x00a9, 0 },
	{ { 0xc0 }, 1, 0x044e, 0 },
	{ { 0xc1 }, 1, 0x0430, 0 },
	{ { 0xc2 }, 1, 0x0431, 0 },
	{ { 0xc3 }, 1, 0x0446, 0 },
	{ { 0xc4 }, 1, 0x0434, 0 },
	{ { 0xc5 }, 1, 0x0435, 0 },
	{ { 0xc6 }, 1, 0x0444, 0 },
	{ { 0xc7 }, 1, 0x0433, 0 },
	{ { 0xc8 }, 1, 0x0445, 0 },
	{ { 0xc9 }, 1, 0x0438, 0 },
	{ { 0xca }, 1, 0x0439, 0 },
	{ { 0xcb }, 1, 0x043a, 0 },
	{ { 0xcc }, 1, 0x043b, 0 },
	{ { 0xcd }, 1, 0x043c, 0 },
	{ { 0xce }, 1, 0x043d, 0 },
	{ { 0xcf }, 1, 0x043e, 0 },
	{ { 0xd0 }, 1, 0x043f, 0 },
	{ { 0xd1 }, 1, 0x044f, 0 },
	{ { 0xd2 }, 1, 0x0440, 0 },
	{ { 0xd3 }, 1, 0x0441, 0 },
	{ { 0xd4 }, 1, 0x0442, 0 },
	{ { 0xd5 }, 1, 0x0443, 0 },
	{ { 0xd6 }, 1, 0x0436, 0 },
	{ { 0xd7 }, 1, 0x0432, 0 },
	{ { 0xd8 }, 1, 0x044c, 0 },
	{ { 0xd9 }, 1, 0x044b, 0 },
	{ { 0xda }, 1, 0x0437, 0 },
	{ { 0xdb }, 1, 0x0448, 0 },
	{ { 0xdc }, 1, 0x044d, 0 },
	{ { 0xdd }, 1, 0x0449, 0 },
	{ { 0xde }, 1, 0x0447, 0 },
	{ { 0xdf }, 1, 0x044a, 0 },
	{ { 0xe0 }, 1, 0x042e, 0 },
	{ { 0xe1 }, 1, 0x0410, 0 },
	{ { 0xe2 }, 1, 0x0411, 0 },
	{ { 0xe3 }, 1, 0x0426, 0 },
	{ { 0xe4 }, 1, 0x0414, 0 },
	{ { 0xe5 }, 1, 0x0415, 0 },
	{ { 0xe6 }, 1, 0x0424, 0 },
	{ { 0xe7 }, 1, 0x0413, 0 },
	{ { 0xe8 }, 1, 0x0425, 0 },
	{ { 0xe9 }, 1, 0x0418, 0 },
	{ { 0xea }, 1, 0x0419, 0 },
	{ { 0xeb }, 1, 0x041a, 0 },
	{ { 0xec }, 1, 0x041b, 0 },
	{ { 0xed }, 1, 0x041c, 0 },
	{ { 0xee }, 1, 0x041d, 0 },
	{ { 0xef }, 1, 0x041e, 0 },
	{ { 0xf0 }, 1, 0x041f, 0 },
	{ { 0xf1 }, 1, 0x042f, 0 },
	{ { 0xf2 }, 1, 0x0420, 0 },
	{ { 0xf3 }, 1, 0x0421, 0 },
	{ { 0xf4 }, 1, 0x0422, 0 },
	{ { 0xf5 }, 1, 0x0423, 0 },
	{ { 0xf6 }, 1, 0x0416, 0 },
	{ { 0xf7 }, 1, 0x0412, 0 },
	{ { 0xf8 }, 1, 0x042c, 0 },
	{ { 0xf9 }, 1, 0x042b, 0 },
	{ { 0xfa }, 1, 0x0417, 0 },
	{ { 0xfb }, 1, 0x0428, 0 },
	{ { 0xfc }, 1, 0x042d, 0 },
	{ { 0xfd }, 1, 0x0429, 0 },
	{ { 0xfe }, 1, 0x0427, 0 },
	{ { 0xff }, 1, 0x042a, 0 }
};

#if defined( __cplusplus )
}
#endif

#endif /* !defined( _UNA_TEST_CODEPAGE_KOI8_R_H ) */

